// Camera.h: interface for the Camera class.
//
//////////////////////////////////////////////////////////////////////


#ifdef MACOSX
#include <glut.h>
#else
#include <GL/glut.h>
#endif
#include <math.h>
#include "Scene.h"

#if !defined(AFX_CAMERA_H__344C174F_8399_4074_9288_1ECF93F36EE2__INCLUDED_)
#define AFX_CAMERA_H__344C174F_8399_4074_9288_1ECF93F36EE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Camera  
{
private:
	Point3 eye, look;
	Vector3 u,v,n;
	double viewAngle, aspect, nearDist, farDist, wWidth, wHeight;
	void setModelViewMatrix(void);

public:
	Camera();
	virtual ~Camera();
	void set(Point3 eye, Point3 look, Vector3 up);
	void roll(float angle);
	void pitch(float angle);
	void yaw(float angle);
	void slide(float delU, float delV, float delN);
	void setShape(float vAng, float asp, float nearD, float farD);
	void raytrace(Scene& scn, int blocksize);
};

#endif // !defined(AFX_CAMERA_H__344C174F_8399_4074_9288_1ECF93F36EE2__INCLUDED_)
